// Cubeの回転（角度値）（Arduino側）
// 2017.12 nakayasu
 
int sensorValue[3];
int inByte; // 受信データ
 
void setup()
{
  for(int k=0; k < 3; k++) sensorValue[k] = 0; 
  Serial.begin(9600); establishContact(); // シリアル通信確立用 
} 
void loop() { 
  if (Serial.available() > 0) {
    inByte = Serial.read(); //シリアル受信
    sensorValue[0] = analogRead(1); //A1ピン入力 - Z(KXM52-1050の8pin)
    delay(10);
    sensorValue[1] = analogRead(2); //A2ピン入力 - Y(KXM52-1050の7pin)
    delay(10);
    sensorValue[2] = analogRead(3); //A3ピン入力 - X(KXM52-1050の6pin)
    delay(10);

    //センサー値を-1から1までの範囲にスケーリングしてsinθの値とする
    float xAxisSinTheta = mapInFloat(sensorValue[2], 306, 716, -1, 1);
    float yAxisSinTheta = mapInFloat(sensorValue[1], 306, 716, -1, 1);
    //値を-1から1までの範囲に制限
    xAxisSinTheta = constrain(xAxisSinTheta,-1,1);
    yAxisSinTheta = constrain(yAxisSinTheta,-1,1);
    //逆サインのラジアンを度に変換する
    int xAxisTilt = float(asin(xAxisSinTheta) * 180 / PI );
    int yAxisTilt = float(asin(yAxisSinTheta) * 180 / PI );
    // シリアル送信
    Serial.write(xAxisTilt);
    Serial.write(yAxisTilt);
  }
}
 
void establishContact() { // シリアル通信が確立されるまでAを送信し続ける
  while (Serial.available() <= 0) {
    Serial.print('A');
    delay(300);
  }
}

float mapInFloat(float x, float iMin, float iMax, float oMin, float oMax) {
  return (x - iMin) * (oMax - oMin) / (iMax - iMin) + oMin;
}
